package bytecrafters.inspector;

import java.lang.reflect.Array;

/**
 * Author: Rhett
 * Date: Feb 25, 2003
 * Time: 12:12:33 AM
 */
public class ArrayInspector extends Inspector {
    public ArrayInspector( String label, Object value ){
        super( label, value, value != null && Array.getLength( value ) > 0 );
    }

    protected void loadChildren() {
        Class componentType = userObject.getClass().getComponentType();
        int arrayLength = Array.getLength( userObject );

        for( int i = 0; i < arrayLength; i++ )
            add( createInspector( "[" + i + "]", componentType, Array.get( userObject, i ) ) );
    }
}
