package bytecrafters.reflect;

/**
 * Author: Rhett
 * Date: Feb 24, 2003
 * Time: 11:44:33 PM
 */
public class Classes {
    public static String toString( Object object ){
        if( object == null )
            return "null";

        return object.getClass().isArray() ? Arrays.toString( object ) : object.toString();
    }

    public static String getName( Class c ){
        String fullName = c.getName();
        int lastDot = fullName.lastIndexOf( '.' );

        if( lastDot == -1 )
            return fullName;

        return fullName.substring( lastDot + 1 );
    }

    public static String getPrintableName( Class type ){
        StringBuffer buf = new StringBuffer();

        while( type.isArray() ){
            buf.append( "[]");
            type = type.getComponentType();
        }

        return type.getName() + buf.toString();
    }

    public static Class getPrimitiveType( Object object  ){
        Class c = object.getClass();

        if( c == Boolean.class )
            return Boolean.TYPE;
        if( c == Byte.class )
            return Byte.TYPE;
        if( c == Character.class )
            return Character.TYPE;
        if( c == Short.class )
            return Short.TYPE;
        if( c == Integer.class )
            return Integer.TYPE;
        if( c == Long.class )
            return Long.TYPE;
        if( c == Float.class )
            return Float.TYPE;
        if( c == Double.class )
            return Double.TYPE;

        return c; // shouldnt get here

    }
}
