package bytecrafters.scrappy.intellij;

import bytecrafters.scrappy.IClassContext;
import bytecrafters.scrappy.Scrappy;
import bytecrafters.reflect.Classes;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.projectRoots.ProjectRootManager;
import com.intellij.openapi.vfs.VirtualFile;
import com.intellij.openapi.application.PathManager;

import java.io.File;
import java.net.URL;
import java.net.MalformedURLException;
import java.net.URLClassLoader;

import net.sf.pizzacompiler.compiler.Main;
import net.sf.pizzacompiler.compiler.ClassReader;

/**
 * Created by IntelliJ IDEA.
 * User: Rhett
 * Date: Feb 21, 2003
 * Time: 7:22:22 AM
 * To change this template use Options | File Templates.
 */
public class IntellijClassContext implements IClassContext {
    private Project project;

    public IntellijClassContext(Project project) {
        this.project = project;
    }

    public ClassLoader getContextClassLoader(){
        String[] classPath = getClassPath();
        URL[] classPathURLs = new URL[ classPath.length ];
        StringBuffer classPathString = new StringBuffer();

        try {
            for( int i = 0; i < classPath.length; i++ ){
                classPathString.append( classPath[i] ).append( File.pathSeparatorChar );
                classPathURLs[i] = new File( classPath[i]).toURL();
            }
        }
        catch( MalformedURLException ex ){
        }

        Main.setClassReader( new ClassReader( null, classPathString.toString() ) );
        ClassLoader rootLoader = Thread.currentThread().getContextClassLoader();
        return new URLClassLoader(classPathURLs, rootLoader);

    }

    protected String[] getClassPath() {
        ProjectRootManager rootManager = (ProjectRootManager) project.getComponent(ProjectRootManager.class);
        VirtualFile[] virtualFiles = rootManager.getFullClassPath();
        String[] classPath = new String[virtualFiles.length+1];

        for (int i = 0; i < virtualFiles.length; i++) {
            String path = virtualFiles[i].getPath();
            classPath[i] = path.endsWith("!/") ? path.substring(0, path.length() - 2) : path;
        }

        classPath[classPath.length-1] = PathManager.getPluginsPath() + File.separatorChar + Classes.getName(Scrappy.class) + ".jar";
        return classPath;
    }
}
